#!/bin/bash
# By John 2006-01-01
# Original: http://linc.homeunix.org:8080/scripts/bashpodder
#           linc dot fessenden at gmail dot com

# Make script crontab friendly
cd $(dirname $0)

# Datadir is the directory you want podcasts saved to
datadir=$(date +%Y-%m-%d)

# Create datadir if necessary
if test ! -d $datadir
	then
	mkdir $datadir
fi

# Read the podget.feeds file
while read feed num
	do
	filecount=0
	# Extract the urls from each RSS feed
	urls=$(wget -q $feed -O - |xsltproc podget.xsl - 2>/dev/null) \
		||urls=$(wget -q $feed -O - | tr '\r' '\n' | tr \' \" \
			|sed -n 's/.*url="\([^"]*\)".*/\1/p')
	# Process each URL
	for url in $urls
		do
		filename=$(basename $url)
		# If the file has never been downloaded
		if ! grep "$filename" podget.log > /dev/null
			then
			# Also if the file does not exist
			if test ! -e "$datadir/$filename"
				then
				# Only download up to <num> $urls in $file
				# If $num is blank then there is no limit
				if (test ! $num || expr $filecount \< $num) >/dev/null
					then
					# Treat each offered filetype seperately
					case "$filename" in
						# Download mp3 files
						*.[Mm][Pp]3)
							wget -q -P $datadir "$url"
							filecount=$(expr $filecount + 1)
							# Add file to m3u playlist
							echo $filename >> $datadir/podget.m3u
							# Log the successful download
							echo $filename >> podget.log
							;;
						# Uncomment the following to get m4u files
						#*.[Mm]4[Uu])
						#	wget -q -P $datadir "$url"
						#	;;
						# Uncomment one of the following to get movies as well
						# *.[Mm][Oo][Vv])
						#	wget -q -P $datadir "$url" 
						#   mplayer -dumpstream "$url" -dumpfile "$filename"
						#	;;
						# Uncomment the following to get anything
						#*)
						#	wget -q -P $datadir "$url"
						#	;;
					esac
				fi
			fi
		fi
		done
	done < podget.feeds

exit 0
